/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup DMA
  * @{
  */

/**
  * @addtogroup DMA_Software
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
DMA_InitTypeStruct DMA_InitStructType;

/* Private define ---------------------------------------------------------------*/
#define NUM 5

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint8_t dst_buf[NUM];
uint8_t src_buf[NUM] = {0x11, 0x22, 0x33, 0x44, 0x55};
volatile uint32_t int_flag_cnt_finish = 0;

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();
  
  /* Configure the system tick */
  SystickInit();
  
  /* LED Init */
  EVAL_LedInit(LED1);

  /* Print Uart Init */
  EVAL_ComInit();

  /********************* Operation  *********************/
  /* Enable clock */
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_DMA, ENABLE);
  RCC_Lock();
  printf("********************* Before  *********************\n");

  for(uint8_t i = 0; i < NUM; i++)
  {
    printf("*src_buf[%d] = %d\n", i, src_buf[i]);
    printf("-dst_buf[%d] = %d\n", i, dst_buf[i]);
  }

  /* Config DMA */
  DMA_DeInit(DMA_CH0);
  DMA_InitStructType.DMA_CICRState = DISABLE;
  DMA_InitStructType.DMA_DataNum = 5 - 1;
  DMA_InitStructType.DMA_DataSize = DMA_DATA_SIZE_8;
  DMA_InitStructType.DMA_DstAddr = (uint32_t)dst_buf;
  DMA_InitStructType.DMA_DstIncMode = DMA_ADDR_MODE_INCREASE;
  DMA_InitStructType.DMA_ErrIntState = DISABLE;
  DMA_InitStructType.DMA_FISIntState = ENABLE;
  DMA_InitStructType.DMA_ReqSource = DMA_SW_TRIG_REQ;
  DMA_InitStructType.DMA_RoundNum = 1 - 1;
  DMA_InitStructType.DMA_SrcAddr = (uint32_t)src_buf;
  DMA_InitStructType.DMA_SrcIncMode = DMA_ADDR_MODE_INCREASE;
  DMA_Init(DMA_CH0, &DMA_InitStructType);
  DMA_Cmd(DMA_CH0, ENABLE);
  /* Clear interrupt count */
  int_flag_cnt_finish = 0;
  /* Enable interrupt */
  NVIC_SetPriority(DMA_IRQn, 2);
  NVIC_EnableIRQ(DMA_IRQn);
  DMA_IntCmd(DMA_CH0, DMA_INT_TYPE_FINISH, ENABLE);
  /* Software trigger trasmit */
  DMA_SoftTriggerTransmit(DMA_CH0);

  /* Waiting for transmission to complete */
  while(int_flag_cnt_finish == 0);

  if(int_flag_cnt_finish)
  {
    GPIO_SetBit(GPIOC, GPIO_PIN_12);
  }

  printf("********************* After  *********************\n");

  for(uint8_t i = 0; i < NUM; i++)
  {
    printf("*src_buf[%d] = %d\n", i, src_buf[i]);
    printf("-dst_buf[%d] = %d\n", i, dst_buf[i]);
  }

  uint32_t ledTime = 0;
  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
  }
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(EVAL_COM0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE));

  return ch;
}


/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
